#include <unistd.h>
#include "sgetopt.h"
#include "strerr2.h"
#include "djbunix.h"
#include "execline.h"

char const *PROG = "ifte" ;
#define USAGE "ifte [ -n ] ~command-then... ; ~command-else... ; command-if..."

int main (int argc, char const **argv, char const *const *envp)
{
  int argc1, argc2, wstat ;
  unsigned char not = 0 ;
  int pid ;
  {
    register int opt ;
    while ((opt = subgetopt(argc, argv, "n")) != opteof)
      switch (opt)
      {
        case 'n' : not = 1 ; break ;
        default : strerr_dieusage(100, USAGE) ;
      }
    argc -= optind ;
    argv += optind ;
  }
  argc1 = el_semicolon(argv) ;
  if (argc1 >= argc) strerr_dief1x(100, "unterminated then block") ;
  if (argc1 + 1 == argc) strerr_dief1x(100, "else block required") ;
  argc2 = el_semicolon(argv + argc1 + 1) ;
  if (argc1 + argc2 + 1 >= argc) strerr_dief1x(100, "unterminated else block") ;
  if (argc1 + argc2 + 2 >= argc) strerr_dief1x(100, "empty progif") ;

  pid = fork() ;
  switch (pid)
  {
    case -1: strerr_diefu1sys(111, "fork") ;
    case 0:
      pathexec_run(argv[argc1 + argc2 + 2], argv + argc1 + argc2 + 2, envp) ;
      strerr_diewu2sys(111, "spawn ", argv[argc1 + argc2 + 2]) ;
  }
  if (wait_pid(&wstat, pid) == -1)
    strerr_diefu2sys(111, "wait for ", argv[argc1 + argc2 + 2]) ;
  if (wait_status(wstat) ? !not : not)
  {
    argv += ++argc1 ;
    argc1 += argc2 ;
  }
  argv[argc1] = 0 ;
  pathexec0_run(argv, envp) ;
  strerr_dieexec(111, *argv) ;
}
